'***************************************************
'DEV by:
'Daniele De Santis
'desantis@areasx.com
'www.areasx.com
'www.desantix.it
'Ver 1.0.0
'Data: 
'Ethernet - BasicX24
'***************************************************
Option Explicit

Public Const InputBufferSize As Integer = 50
Public InputBuffer(1 To InputBufferSize) As Byte

Public Const OutputBufferSize As Integer = 50
Public OuputBuffer(1 To OutputBufferSize) As Byte


'-----------------------------------------------
'Funzioni per la comunicazione con la seriale
'-----------------------------------------------

'FUNZIONE PER INVIARE UNA STRINGA
Public Sub PutStr( _
   ByVal Tx As String)
   Call PutQueueStr(OuputBuffer, Tx)

End Sub

'FUNZIONE PER RICEVERE UN BYTE
Public Sub GetByte( _
    ByRef Value As Byte, _
    ByRef Success As Boolean)

    Success = StatusQueue(InputBuffer)

    If (Success) Then
        Call GetQueue(InputBuffer, Value, 1)
    Else
        Value = 0
    End If

End Sub

'FUNZIONE PER RICEVERE UNA STRINGA
Public Function GetStr( _
    ByVal BufferSize As Integer, _
    ByVal Delay_read As Single) As String

    Dim Key As Byte
    Dim Success As Boolean
    Dim I As Integer
    Dim Value As string
    
    Call Delay(Delay_read)
    Value=""
    For I = 1 To BufferSize
        Call GetByte(Key, Success)
        if(Success) then
	   	Value=Value & chr(Key)	 
        End if
	
    Next  
    GetStr = 	Value

End Function


Sub Put2Bits (ByVal bByte As Byte, _
	ByVal MSBbit As Byte)
 
	Dim bMask As Byte
	Dim bCount As Byte
	
	bMask = bx00001000
	For bCount = 0 to 3 'Put most significant bits first
		Call PutPin(MSBbit + bCount, ((bByte And bMask)\bMask))
		bMask = bMask \ 2
	Next

End Sub 
'#3
Function Str2byte (ByVal stringa As string) As byte
	Dim TmpSng As Single
	Dim Success As Boolean	

	Call ValueS(stringa, TmpSng, Success)
	Str2byte = Cbyte(TmpSng)	
End Function 

'-----------------------------------------------
'FINE Funzioni per la comunicazione con la seriale
'-----------------------------------------------



'-------------------------------
'
'PROGRAMMA PRINCIPALE
'
'-------------------------------

Public Sub Main()

    'Parametri della seriale 
    Const PortNumber As Byte = 3   
    Const TxPin As Byte = 20
    Const RxPin As Byte = 19
    Const BaudRate As Long = 9600
	Const LED_RED As Byte = 25
	Const LED_CONNECT As Byte = 26
	
	'VARIE
	Const DELAY_SEND As single  = 0.1

	'VARIABILI
	Dim i as byte
	Dim buffer As String
	Dim tmpInt as integer
	Dim cmd As String * 1
	Dim line as String * 1
	Dim state as string * 1
	Dim line_state(4) as byte
	Dim tmpByte as byte
	dim enabled as boolean


	'CONFIGURA LA SERIALE SW
    Call OpenQueue(InputBuffer, InputBufferSize)
    Call OpenQueue(OuputBuffer, OutputBufferSize)
    Call DefineCom3(RxPin, TxPin, bx0000_1000) 'Setta la seriale come inverted, no parity, 8 bits.    
    Call OpenCom(PortNumber, BaudRate, InputBuffer, OuputBuffer)
	
    Debug.Print "Bluetooth"
    Debug.Print "Dev By DeSantiX.iT"
	

	line_state(1) = 0
	line_state(2) = 0
	line_state(3) = 0
     line_state(4) = 0
     enabled=true
	
    'LOOP
    Do
		Call PutPin(LED_RED, 0)
		
		If(GetPin(5)=1) Then
			
			Call PutPin(LED_CONNECT, 0)

			buffer = ""
    			buffer = GetStr(InputBufferSize, 0.01)
			tmpInt = Len(buffer)
		

			if(tmpInt>2) then
				debug.print buffer
				cmd = mid(buffer,1,1)
				line = mid(buffer,2,1)
				state = mid(buffer,3,1)
				If ((asc(cmd) = asc("L")) and (Str2byte(line) >=0) And ((Str2byte(state) = 1) Or (Str2byte(state) = 0))) then
					line_state(Str2byte(line))=Str2byte(state)
					Call PutPin((Str2byte(line) + 9), Str2byte(state))
					'debug.print "Comando Valido"
				End if
				tmpByte =0
				for i=1 to 4		
				 	tmpByte =  tmpByte + (line_state(i) * cbyte(pow(2.0, csng(i-1)))	) 				
				next			
				
				if(tmpByte > 9)then
					buffer =  cstr(tmpByte)
				else
					buffer = "0" & cstr(tmpByte)
				end if 
					
				call PutStr(buffer)
				'debug.print "END TX" & buffer
			End if
		Else 
              enabled = false	
			Call PutPin(LED_CONNECT, 1)
		End if
		Call Delay(DELAY_SEND)
		Call PutPin(LED_RED, 1)
		Call Delay(0.1)
    Loop

End Sub

